import com.j256.ormlite.dao.Dao;
import com.j256.ormlite.dao.DaoManager;
import com.j256.ormlite.jdbc.JdbcConnectionSource;
import com.j256.ormlite.support.ConnectionSource;


import java.util.Scanner;

public class AccountApp {

    // we are using a MySQl database
    private final static String DATABASE_URL = "jdbc:mysql://localhost:3306/orm_lab?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

    private Dao<Account, Integer> accountDao;

    public static void main(String[] args) throws Exception {
        // turn our static method into an instance of Main
        new AccountApp().doMain(args);
    }

    private void doMain(String[] args) throws Exception {
        ConnectionSource connectionSource = null;
        try {
            // create our data-source for the database
            connectionSource = new JdbcConnectionSource(DATABASE_URL, "root", "Samsimsam@91");
            // setup our  DAOs
            setupDao(connectionSource);
            boolean run = true;
 while (run) {
     Scanner scanner = new Scanner(System.in);
     System.out.println("Welcome to account services, please select an option: " + "\n");
     System.out.println("Enter 1 to Create " + "\n" + "Enter 2 to Read " + "\n" + "Enter 3 to Update " + "\n" + "Enter 4 to Delete " + "\n" + "Enter 5 to Exit " + "\n");
     int choice = scanner.nextInt();
     switch (choice) {
         case 1:
             createData();
             break;
         case 2:
             readData();
             break;
         case 3:
             updateData();
             break;
         case 4:
             deleteData();
             break;
         case 5:
             run = false;
             break;
     }
 }

        } finally {
            // destroy the data source which should close underlying connections
            if (connectionSource != null) {
                connectionSource.close();
            }
        }
    }

    /**
     * Read and write some example data.
     */
    private void processData() throws Exception {
        // create an instance of Account
        String name = "Jim Coakley";
        Account account = new Account(name);

        // persist the account object to the database
        accountDao.create(account);
        int id = account.getId();
        System.out.println(id);
        // assign a password
        account.setPassword("_secret");
        // update the database after changing the object
        accountDao.update(account);
        // delete the account
        //accountDao.deleteById(id);
    }

    private void createData() throws Exception {
        // create an instance of Account

        Scanner scanner= new Scanner(System.in);
        System.out.println("Enter the name: ");
        String name = scanner.nextLine();
        Account account = new Account(name);
        accountDao.create(account);

    }

    private void readData() throws Exception {


        Scanner scanner= new Scanner(System.in);
        System.out.println("Enter the id for the record you want to read: ");
        int id = scanner.nextInt();
        Account account1 = accountDao.queryForId(id); // returns account object where id is equal to user input
        String resultAccount = account1.getName(); // using getter to get the //everyrow in database is one object in java //always fetch row you want to make changes to.pw
        System.out.println( "The account is :" + resultAccount );
        String resultPassword = account1.getPassword();
        System.out.println( "The password is :" + resultPassword );

    }


    private void updateData() throws Exception {
        Scanner scanner= new Scanner(System.in);
        System.out.println("Enter the id for the record you want to update: ");
        int id = scanner.nextInt();
        Account account1 = accountDao.queryForId(id); // equivalted to database query: select * from account where id = user_input;
        Scanner scanner1= new Scanner(System.in);

        System.out.println("Enter the updated Name: ");
        String updatedName = scanner1.nextLine();
        account1.setName(updatedName);

        Scanner scanner2= new Scanner(System.in);
        System.out.println("Enter the updated Password: ");
        String updatedPassword = scanner2.nextLine();
        account1.setPassword(updatedPassword);
        accountDao.update(account1);
        System.out.println("Update successful for id : " + id);


    }


    private void deleteData() throws Exception {
        Scanner scanner= new Scanner(System.in);
        System.out.println("Enter the id for the record you want to delete: ");
        int id = scanner.nextInt();
        accountDao.deleteById(id);
        System.out.println("Delete successful for id : " + id);
    }




    /**
     * Setup our  DAOs
     */
    private void setupDao(ConnectionSource connectionSource) throws Exception {

        accountDao = DaoManager.createDao(connectionSource, Account.class);

    }
}
